routes/web.php
<?php

use App\Http\Controllers\Admin;
use App\Http\Controllers\Supplier;
use Illuminate\Routing\Controller;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\POSController;
use App\Http\Controllers\SiteController;
use App\Http\Controllers\Admin\UserController;
use App\Http\Controllers\Admin\OrderController;
use App\Http\Controllers\Admin\StockController;
use App\Http\Controllers\Admin\PurchaseController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [SiteController::class, 'index'])->name('index');
Route::get('/home', [SiteController::class, 'home'])
    ->name('home')
    ->middleware('auth');
Route::get('/404', [SiteController::class, 'notFound'])->name('404');

Route::controller(POSController::class)
    ->middleware('cashier')
    ->prefix('/pos')
    ->name('pos.')
    ->group(function () {
        Route::get('/', 'index')->name('index');
        Route::post('/select-customer', 'selectCustomer')->name('customer.select');
        Route::post('/new-customer', 'createCustomer')->name('customer.create');
        Route::post('/no-customer', 'emptyCustomer')->name('customer.none');

        Route::get('/order/{order}', 'order')->name('order');
        Route::post('/order/{order}/status', 'changeStatus')->name('status');
        Route::post('/order/{order}/products', 'addProduct')->name('products.store');
        Route::get('/order/{order}/{product_order}/delete', 'deleteProduct')->name('products.delete');
        Route::post('/order/{order}/quantity', 'updateQuantity')->name('quantity');
    });

Route::middleware(['auth', 'admin'])->prefix('/admin')->name('admin.')->group(function () {
    Route::get('/', [Admin\AdminController::class, 'index'])->name('index');

    //CRUD
    Route::resource('categories', Admin\CategoryController::class);
    Route::resource('suppliers', Admin\SupplierController::class);
    Route::resource('customers', Admin\CustomerController::class);

    Route::controller(Admin\ProductController::class)->name('products.')->group(function () {
        Route::get('products/{product}/variants', 'variants')->name('variants');
        Route::post('products/{product}/variants', 'addVariant')->name('variants');
        Route::delete('products/{product}/variants/{variant}', 'removeVariant')->name('variants.delete');
        Route::get('products/search', 'search')->name('search');
    });

    Route::resource('products', Admin\ProductController::class);
    Route::get('batches/{batch}/products', [Admin\BatchController::class, 'products'])->name('batches.products.index');
    Route::post('batches/{batch}/products', [Admin\BatchController::class, 'addProduct'])->name('batches.products.store');
    Route::delete('batches/{batch}/products/{batchproduct}', [Admin\BatchController::class, 'deleteProduct'])->name('batches.products.destory');
    Route::resource('batches', Admin\BatchController::class);
    Route::resource('batchproducts', Admin\BatchProductController::class);
    Route::resource('stocks', Admin\StockController::class);

    Route::get('purchases/supplies', [Admin\PurchaseController::class, 'supplies'])->name('purchases.supplies.index');
    Route::get('purchases/{purchase}/approve', [Admin\PurchaseController::class, 'approve'])->name('purchases.supplies.approve');
    Route::delete('purchases/{purchase}/decline', [Admin\PurchaseController::class, 'decline'])->name('purchases.supplies.decline');
    Route::resource('purchases', Admin\PurchaseController::class);

    Route::resource('users', Admin\UserController::class);
    Route::prefix('orders')->name('orders.')->controller(Admin\OrderController::class)->group(function () {
        Route::post('{order}/status', 'changeStatus')->name('status');
        Route::post('{order}/products', 'addProduct')->name('products.store');
        Route::get('{order}/{product_order}/quantity', 'editQuantity')->name('products.quantity');
        Route::post('{order}/{product_order}/quantity', 'updateQuantity');
        Route::get('{order}/{product_order}/delete', 'deleteProduct')->name('products.delete');
    });
    Route::resource('orders', Admin\OrderController::class);

    Route::get('/reports', [Admin\ReportController::class, 'index'])->name('reports.index');
    Route::get('/reports/view', [Admin\ReportController::class, 'view'])->name('reports.view');
});


Route::middleware(['auth', 'supplier'])->prefix('/supplier')->name('supplier.')->group(function () {
    Route::get('/', [Supplier\SupplierController::class, 'index'])->name('index');


    //CRUD
    Route::controller(Supplier\ProductController::class)->name('products.')->group(function () {
        Route::get('products/{product}/variants', 'variants')->name('variants');
        Route::post('products/{product}/variants', 'addVariant')->name('variants');
        Route::delete('products/{product}/variants/{variant}', 'removeVariant')->name('variants.delete');
        Route::get('products/search', 'search')->name('search');
    });
    Route::resource('products', Supplier\ProductController::class);
    Route::resource('purchases', Supplier\PurchaseController::class);
    Route::resource('suppliers', SupplierController::class);
    Route::resource('variants', \App\Http\Controllers\Supplier\ProductController::class);
    // Route::resource('customers', CustomerController::class);
    // Route::resource('products', ProductController::class);
    // Route::resource('variants', VariantController::class);
});

app/Models/Customer.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Customer extends Model
{
    use HasFactory;

    protected $fillable = [
        'name', 'email', 'address', 'phone', 'media_id'
    ];

    public function media()
    {
        return $this->belongsTo(Media::class);
    }
}

app/Http/Controllers/Admin/CustomerController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Models\Customer;
use Illuminate\Http\Request;
use App\Services\MediaService;
use App\Http\Controllers\Controller;

class CustomerController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $customers = Customer::simplePaginate(5);

        return view('admin.customers.index', compact('customers'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('admin.customers.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $request->validate([
            'name' => ['required'],
            'email' => ['required'],
            'address' => ['required'],
            'phone' => ['required'],
            'image' => ['nullable', 'image', 'mimes:png,jpeg,gif'],
        ]);

        if ($request->hasFile('image')) {
            $media_id = MediaService::upload($request->file('image'), "customers");
        }

        Customer::create([
            'name' => $request->name,
            'email' => $request->email,
            'address' => $request->address,
            'phone' => $request->phone,
            'media_id' => $media_id ?? null,
        ]);

        return redirect()->route('admin.customers.index')
            ->with('success', 'Customer Created Successfully!');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Customer  $customer
     * @return \Illuminate\Http\Response
     */
    public function show(Customer $customer)
    {
        return view('admin.customers.show', compact('customer'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Customer  $customer
     * @return \Illuminate\Http\Response
     */
    public function edit(Customer $customer)
    {
        return view('admin.customers.edit', compact('customer'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Customer  $customer
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Customer $customer)
    {
        $request->validate([
            'name' => ['required',],
            'email' => ['required'],
            'address' => ['required'],
            'phone' => ['required'],
        ]);


        $customer->update([
            'name' => $request->name,
            'email' => $request->email,
            'address' => $request->address,
            'phone' => $request->phone,

        ]);

        return redirect()->route('admin.customers.index')
            ->with('success', 'Customer Updated Successfully!');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Customer  $customer
     * @return \Illuminate\Http\Response
     */
    public function destroy(Customer $customer)
    {
        $customer->delete();

        return redirect()->route('admin.customers.index')
            ->with('success', 'Customer Deleted Successfully!');
    }
}

resources/views/admin/customers/create.blade.php
@extends('adminlte::page')

@section('title', 'Add New Customer')

@section('content')

<x-alert />

<div class="card">
    <div class="card-header">

        <h3 class="card-title" style="font-size: 1.5rem;line-height:1.8;font-weight:bold">
            Add New Customer
        </h3>

        <div class="card-tools">
            <a class="btn btn-outline-secondary" href="{{ route('admin.customers.index') }}"> <i class="fas fa-arrow-circle-left mr-2"></i>Go Back</a>
        </div>

    </div>

      <div class="card-body">
          <form action="{{ route('admin.customers.store') }}" method="post" enctype="multipart/form-data">
            @csrf

            <div class="form-group">
                <label for="name">Name</label>
                <input type="text" name="name" id="name" class="form-control">
            </div>

            <div class="form-group">
                <label for="email">Email</label>
                <input type="text" name="email" id="email" class="form-control">
            </div>

            <div class="form-group">
                <label for="phone">Phone</label>
                <input type="text" name="phone" id="phone" class="form-control">
            </div>

            <div class="form-group">
                <label for="address">Address</label>
                <input type="text" name="address" id="address" class="form-control">
            </div>

            <div class="form-group">
                <label for="image">Photo</label>
                <input type="file" name="image" id="image" class="form-control-file @error('image') is-invalid
                    
                @enderror">

                @error('image')
                    <small class="form-text text-danger">{{ $message }}</small>
                @enderror

            </div>

            <button class="btn btn-outline-secondary">
                <i class="fas fa-save mr-2"></i>
                Save
            </button>
          </form>
      </div>

</div>

@endsection

resources/views/admin/customers/edit.blade.php
@extends('adminlte::page')

@section('title', 'Edit Customer')

@section('content')

<x-alert />

<div class="card">
    <div class="card-header">

        <h3 class="card-title" style="font-size: 1.5rem;line-height:1.8;font-weight:bold">
            Edit Customer
        </h3>

        <div class="card-tools">
            <a class="btn btn-outline-secondary" href="{{ route('admin.customers.index') }}"> 
                <i class="fas fa-arrow-circle-left mr-2"></i>
                Go Back
            </a>
        </div>

    </div>

      <div class="card-body">
          <form action="{{ route('admin.customers.update', $customer) }}" method="post" enctype="multipart/form-data">
            @csrf
            @method('PUT')

            <div class="form-group">
                <label for="name">Name</label>
                <input type="text" name="name" id="name" class="form-control" value="{{ $customer->name }}">
            </div>

            <div class="form-group">
                <label for="email">Email</label>
                <input type="text" name="email" id="email" class="form-control" value="{{ $customer->email }}">
            </div>

            <div class="form-group">
                <label for="phone">Phone</label>
                <input type="text" name="phone" id="phone" class="form-control" value="{{ $customer->phone }}">
            </div>

            <div class="form-group">
                <label for="address">Address</label>
                <input type="text" name="address" id="address" class="form-control" value="{{ $customer->address }}">
            </div>


            <button class="btn btn-outline-secondary">
                <i class="fas fa-save mr-2"></i>
                Save
            </button>
          </form>
      </div>

</div>

@endsection

resources/views/admin/customers/index.blade.php
@extends('adminlte::page')

@section('title', 'All Customers')

@section('content')

<x-alert />

<div class="card">
    <div class="card-header">

        <h3 class="card-title" style="font-size: 1.5rem;line-height:1.8;font-weight:bold">
            All Customers
        </h3>

        <div class="card-tools">
            <a class="btn btn-outline-secondary" href="{{ route('admin.customers.create') }}"> <i class="fas fa-user-plus mr-2"></i>Add New</a>
        </div>

    </div>

      <div class="card-body p-0">
          <table class="table table-bordered table-striped">
              <thead class="bg-secondary">
                  <tr>
                      <th>ID</th>
                      <th>Name</th>
                      <th>Email</th>
                      <th>Phone</th>
                      <th>Address</th>
                      <th>Photo</th>
                      <th>Date</th>
                      <th>Action</th>
                  </tr>
              </thead>

              <tbody>
                  @foreach ($customers as $customer)
                  <tr>
                      <td>{{ $customer->id }}</td>
                      <td>{{ $customer->name }}</td>
                      <td>{{ $customer->email }}</td>
                      <td>{{ $customer->phone }}</td>
                      <td>{{ $customer->address }}</td>
                      <td>
                          @if ($customer->media)
                              <img src="/storage/{{ $customer->media->path }}" height="70px" />
                          @endif
                      </td>
                      <td>{{ $customer->created_at }}</td>
                      <td>
                          <a class="btn btn-outline-secondary btn-sm" href="{{ route('admin.customers.show', $customer) }}">
                           
                            <i class="fas fa-eye mr-2"></i>
                            Details

                           </a>
                           <a class="btn btn-outline-secondary btn-sm" href="{{ route('admin.customers.edit', $customer) }}">
                           
                            <i class="fas fa-edit mr-2"></i>
                            Edit

                           </a>

                           <form style="display: inline-block" action="{{ route('admin.customers.destroy', $customer) }}" method="post" enctype="multipart/form-data">
                              @csrf
                              @method('DELETE')

                              <button class="btn btn-outline-danger btn-sm">
                                  <i class="fas fa-trash mr-2"></i>
                                  Delete
                              </button>
                          </form>
                      </td>
                  </tr>
                      
                  @endforeach
              </tbody>
          </table>
          @if(count($customers) == 0)
          <div class="alert alert-warning text-center mb-0">
              No Items Found!
          </div>
          @endif
          <div class="card-fotter">       
                 {{ $customers->links() }}
                </div>
          



      </div>

</div>

@endsection

resources/views/admin/customers/show.blade.php
@extends('adminlte::page')

@section('title', 'Customer Details')

@section('content')

<x-alert />

<div class="card">
    <div class="card-header">

        <h3 class="card-title" style="font-size: 1.5rem;line-height:1.8;font-weight:bold">
            Customer Details
        </h3>

        <div class="card-tools">
            <a class="btn btn-outline-secondary" href="{{ route('admin.customers.index') }}"> 
                <i class="fas fa-arrow-circle-left mr-2"></i>
                Go Back
            </a>
        </div>

    </div>

      <div class="card-body p-0">
          <table class="table table-bordered table-striped">
              <tr>
                  <th style="width: 20%">ID</th>
                  <td>{{ $customer->id }}</td>

              </tr>
              <tr>
                <th>Name</th>
                <td>{{ $customer->name }}</td>
                
            </tr>
            <tr>
                <th>Email</th>
                <td>{{ $customer->email }}</td>
                
            </tr>
            <tr>
                <th>Phone</th>
                <td>{{ $customer->phone }}</td>
                
            </tr>
            <tr>
                <th>Address</th>
                <td>{{ $customer->address }}</td>
                
            </tr>
           
            <tr>
                <th>Photo</th>
                <td> @if ($customer->media)
                    <img src="/storage/{{ $customer->media->path }}" height="70px" />
                @endif
                </td>
                
            </tr>
            <tr>
                <th>Created</th>
                <td>{{ $customer->created_at }}</td>
                
            </tr>
            <tr>
                <th>Updated</th>
                <td>{{ $customer->updated_at }}</td>
                
            </tr>
          </table>
          
      </div>

</div>

@endsection